<?php
    include_once dirname(__FILE__) . '/../components/application.php';
    if (GetApplication()->GetCurrentUserId() == null)
    {
        header('Location: ../login.php');
        exit;
    }
?>

<?php

$query_period = "select field from preset where section = 'database' and param = 'edm_period'";
$query_typeid = "select field from preset where section = 'database' and param = 'edm_msg_typeid'";
$query_gln = "select field from preset where section = 'database' and param = 'edm_report_gln'";

$result_period = pg_query($query_period);
if (!$result_period)
{
	echo "Problem with query " . $query_period . "<br/>";
	echo pg_last_error();
	exit();
}

$result_typeid = pg_query($query_typeid);
if (!$result_typeid)
{
	echo "Problem with query " . $result_typeid . "<br/>";
	echo pg_last_error();
	exit();
}

$result_gln = pg_query($query_gln);
if (!$result_gln)
{
	echo "Problem with query " . $result_gln . "<br/>";
	echo pg_last_error();
	exit();
}

$row = pg_fetch_assoc($result_period);
$period = $row['field'];

$row = pg_fetch_assoc($result_typeid);
$typeid = $row['field'];

$row = pg_fetch_assoc($result_gln);
$gln = $row['field'];

$query_data =	 	"SELECT buchung, buchungsart, gtin, sn, sp, g_gn, abfallart, kontamination, 
						   round(sum(masse),0) masse, periode, herkunft, herkunft_typ, herkunft_text, herkunft_vtyp, 
						   herkunft_vtext, verbleib, verbleib_typ, verbleib_text, verbleib_vtyp, 
						   verbleib_vtext, herkunft_name, herkunft_strasse, herkunft_strasse_nr, 
						   herkunft_land, herkunft_plz, herkunft_ort, verbleib_name, verbleib_strasse, 
						   verbleib_strasse_nr, verbleib_land, verbleib_plz, verbleib_ort
					  FROM qedm_result WHERE periode = '" . $period . "'
					  GROUP BY buchung, buchungsart, gtin, sn, sp, g_gn, abfallart, kontamination, 
						   periode, herkunft, herkunft_typ, herkunft_text, herkunft_vtyp, 
						   herkunft_vtext, verbleib, verbleib_typ, verbleib_text, verbleib_vtyp, 
						   verbleib_vtext, herkunft_name, herkunft_strasse, herkunft_strasse_nr, 
						   herkunft_land, herkunft_plz, herkunft_ort, verbleib_name, verbleib_strasse, 
						   verbleib_strasse_nr, verbleib_land, verbleib_plz, verbleib_ort
					  HAVING sum(masse) <> 0
					";


$result_data = pg_query($query_data);
if (!$result_data)
{
	echo "Problem with query " . $result_data . "<br/>";
	echo pg_last_error();
	exit();
}


// Create xml header

$xml = new SimpleXMLElement('<?xml version="1.0" encoding="utf-8"?><WasteHandlingNotification></WasteHandlingNotification>');

$specifiedNotification = $xml->addChild('SpecifiedNotification');
$specifiedNotification->addChild('TypeCode', $typeid);

$obligatedParty = $specifiedNotification->addChild('ObligatedParty');
$obligatedParty->addChild('ID', $gln);

$coveredPeriod = $specifiedNotification->addChild('CoveredPeriod');
$coveredPeriod -> addChild('StartDate', $period."-01-01");
$coveredPeriod -> addChild('EndDate', $period."-12-31");

$SpecifiedSinglePeriodWasteHandlingNotification = $xml->addChild('SpecifiedSinglePeriodWasteHandlingNotification');

// Create data

$count_entry = 1;

while($row = pg_fetch_assoc($result_data))
{
		$SpecifiedWasteHandlingNotificationEntry = $SpecifiedSinglePeriodWasteHandlingNotification->addChild('SpecifiedWasteHandlingNotificationEntry');
		$WasteMaterialMovement = $SpecifiedWasteHandlingNotificationEntry->addChild('WasteMaterialMovement');
		$WasteMaterialMovement->addChild('ID', $count_entry);
		$WasteMaterialMovement->addChild('TypeCode', $row['buchung']);
		$WasteHandOverMovedMaterial = $WasteMaterialMovement->addChild('WasteHandOverMovedMaterial');
		
		$HandOverParty = $WasteHandOverMovedMaterial->addChild('HandOverParty');
		
		// Schauen ob Anlage oder Standort --> Melder GLN und keine Adresse
		if($row['herkunft_typ'] == 'Anlage' or $row['herkunft_typ'] == 'Standort')
		{
			$HandOverParty->addChild('ID', $gln);
			$SpecifiedLocation = $WasteHandOverMovedMaterial->addChild('SpecifiedLocation');
				
			// Schauen ob eine Anlage oder ein Standort anzugeben ist
			if($row['herkunft_typ'] == 'Anlage')	//SpecifiedInstallation
			{
				$SpecifiedOperatingSite = $SpecifiedLocation->addChild('SpecifiedInstallation');
				$SpecifiedOperatingSite->addChild('ID', $row['herkunft']);	// Anlagen GLN - Übergeber
			}			
			if($row['herkunft_typ'] == 'Standort') //SpecifiedOperatingSite
			{
				$SpecifiedOperatingSite = $SpecifiedLocation->addChild('SpecifiedOperatingSite');
				$SpecifiedOperatingSite->addChild('ID', $row['herkunft']);	// Standort GLN - Übergeber
			}		
				
		}
		else
		{
			if ($row['herkunft_typ'] == 'Branche')
			{
				$HandOverParty->addChild('BusinessTypeCode', $row['herkunft']);
			} else {
				$HandOverParty->addChild('ID', $row['herkunft']);
			}				
							
			$SpecifiedOrganization = $HandOverParty->addChild('SpecifiedOrganization');
			$SpecifiedOrganization->addChild('Name', $row['herkunft_name']);			
			$OfficeAddress = $HandOverParty->addChild('OfficeAddress');
			if (!is_null($row['herkunft_ort']))
				$OfficeAddress->addChild('CityName', $row['herkunft_ort']);
			if (!is_null($row['herkunft_plz']))
				$OfficeAddress->addChild('Postcode', $row['herkunft_plz']);
			if (!is_null($row['herkunft_strasse']))
				$OfficeAddress->addChild('StreetName', $row['herkunft_strasse']);
			if (!is_null($row['herkunft_strasse_nr']))
				$OfficeAddress->addChild('BuildingNumber', $row['herkunft_strasse_nr']);
			$OfficeAddress->addChild('CountryID', '040');
			$SpecifiedLocation = $WasteHandOverMovedMaterial->addChild('SpecifiedLocation');
			$PostalAddress = $SpecifiedLocation->addChild('PostalAddress');
			if (!is_null($row['herkunft_ort']))
				$PostalAddress->addChild('CityName', $row['herkunft_ort']);
			if (!is_null($row['herkunft_plz']))
				$PostalAddress->addChild('Postcode', $row['herkunft_plz']);
			if (!is_null($row['herkunft_strasse']))
				$PostalAddress->addChild('StreetName', $row['herkunft_strasse']);
			if (!is_null($row['herkunft_strasse_nr']))
				$PostalAddress->addChild('BuildingNumber', $row['herkunft_strasse_nr']);
			$PostalAddress->addChild('CountryID', '040');						
			
		}
		
		// Abfallherkunftsverfahren
		if (!is_null($row['herkunft_vtyp']))
		{
			$OriginPhysicalProcess = $WasteHandOverMovedMaterial->addChild('OriginPhysicalProcess');
			$OriginPhysicalProcess->addChild('TypeCode', $row['herkunft_vtyp']);
		}

		$WasteTakeOverMovedMaterial = $WasteMaterialMovement->addChild('WasteTakeOverMovedMaterial');
		
		$TakeOverParty = $WasteTakeOverMovedMaterial->addChild('TakeOverParty');
		
		// Schauen ob Anlage oder Standort --> Melder GLN und keine Adresse
		if($row['verbleib_typ'] == 'Anlage' or $row['verbleib_typ'] == 'Standort')
		{
			$TakeOverParty->addChild('ID', $gln);
			$SpecifiedOrganization = $TakeOverParty->addChild('SpecifiedOrganization');
			$SpecifiedOrganization->addChild('Name', $row['verbleib_name']);
			$SpecifiedLocation = $WasteTakeOverMovedMaterial->addChild('SpecifiedLocation');	
			
			if($row['verbleib_typ'] == 'Anlage')	//SpecifiedInstallation
			{
				$SpecifiedOperatingSite = $SpecifiedLocation->addChild('SpecifiedInstallation');
				$SpecifiedOperatingSite->addChild('ID', $row['verbleib']);	// Anlagen GLN - Übergeber
			}
			
			if($row['verbleib_typ'] == 'Standort') //SpecifiedOperatingSite
			{
				$SpecifiedOperatingSite = $SpecifiedLocation->addChild('SpecifiedOperatingSite');
				$SpecifiedOperatingSite->addChild('ID', $row['verbleib']);	// Standort GLN - Übergeber
			}		
															
		}
		else		
		{
			$TakeOverParty->addChild('ID', $row['verbleib']);		
			$SpecifiedOrganization = $TakeOverParty->addChild('SpecifiedOrganization');
			$SpecifiedOrganization->addChild('Name', $row['verbleib_name']);			
			$OfficeAddress = $TakeOverParty->addChild('OfficeAddress');
			if (!is_null($row['verbleib_ort']))
				$OfficeAddress->addChild('CityName', $row['verbleib_ort']);
			if (!is_null($row['verbleib_plz']))
				$OfficeAddress->addChild('Postcode', $row['verbleib_plz']);
			if (!is_null($row['verbleib_strasse']))
				$OfficeAddress->addChild('StreetName', $row['verbleib_strasse']);
			if (!is_null($row['verbleib_strasse_nr']))
				$OfficeAddress->addChild('BuildingNumber', $row['verbleib_strasse_nr']);
			$OfficeAddress->addChild('CountryID', '040');			
			$SpecifiedLocation = $WasteTakeOverMovedMaterial->addChild('SpecifiedLocation');				
			$PostalAddress = $SpecifiedLocation->addChild('PostalAddress');
			if (!is_null($row['verbleib_ort']))
				$PostalAddress->addChild('CityName', $row['verbleib_ort']);
			if (!is_null($row['verbleib_plz']))
				$PostalAddress->addChild('Postcode', $row['verbleib_plz']);
			if (!is_null($row['verbleib_strasse']))
				$PostalAddress->addChild('StreetName', $row['verbleib_strasse']);
			if (!is_null($row['verbleib_strasse_nr']))
				$PostalAddress->addChild('BuildingNumber', $row['verbleib_strasse_nr']);
			$PostalAddress->addChild('CountryID', '040');
						
		}
		
		// Abfallverbleibsverfahren	
		if (!is_null($row['verbleib_vtyp'])) {
			$DesignatedTreatmentPhysicalProcess = $WasteTakeOverMovedMaterial->addChild('DesignatedTreatmentPhysicalProcess');		
			$DesignatedTreatmentPhysicalProcess->addChild('TypeCode', $row['verbleib_vtyp']);
		}
			
		$MovedMaterial = $WasteMaterialMovement->addChild('MovedMaterial');
		$MovedMaterial->addChild('ClassificationCode', $row['gtin']);
		$MassMeasurement = $MovedMaterial->addChild('MassMeasurement');
		$MassMeasurement->addChild('QuantificationTypeCode', '9008390100004');
		$DeterminedMeasure = $MassMeasurement->addChild('DeterminedMeasure', $row['masse']);
		$DeterminedMeasure->addAttribute('unitCode','KGM');
	
	$count_entry++;
}

$query_data =	 	"SELECT 
						period, site_gln, waste_gtin, sum(quantity)::integer as qnt
					 FROM 
						activity_edm_stock 
					 WHERE 
						period = '" . $period . "' and
						report_gln = '" . $gln . "'	and msg_type = 'Lagerstand'			  		
					 GROUP BY 
						period, site_gln, waste_gtin
					";

$result_data = pg_query($query_data);
if (!$result_data)
{
	echo "Problem with query " . $result_data . "<br/>";
	echo pg_last_error();
	exit();
}

while($row = pg_fetch_assoc($result_data))
{

	$specifiedWasteNotification = $SpecifiedSinglePeriodWasteHandlingNotification->addChild('SpecifiedWasteHandlingNotificationEntry');
	$StorageStateInstallation = $specifiedWasteNotification->addChild('StorageStateInstallation');
	$StorageStateInstallation->addChild('ID', $row['site_gln']);
	$StorageStateInstallation->addChild('ReportingDate', $period."-12-31"); 
	$StoredMaterial = $StorageStateInstallation->addChild('StoredMaterial');
	$StoredMaterial->addChild('ClassificationCode', $row['waste_gtin']);
	$MassMeasurement = $StoredMaterial->addChild('MassMeasurement');
	$MassMeasurement->addChild('QuantificationTypeCode','9008390100011');
	$DeterminedMeasure = $MassMeasurement->addChild('DeterminedMeasure', $row['qnt']);
	$DeterminedMeasure->addAttribute('unitCode','KGM');
	$count_entry++;

}


$query_data =	 	"SELECT 
						period, site_gln, waste_gtin, sum(quantity)::integer as qnt
					 FROM 
						activity_edm_stock 
					 WHERE 
						period = '" . ($period-1) . "' and
						report_gln = '" . $gln . "'	and msg_type = 'Lagerstand'			  		
					 GROUP BY 
						period, site_gln, waste_gtin
					";

$result_data = pg_query($query_data);
if (!$result_data)
{
	echo "Problem with query " . $result_data . "<br/>";
	echo pg_last_error();
	exit();
}

while($row = pg_fetch_assoc($result_data))
{

	$specifiedWasteNotification = $SpecifiedSinglePeriodWasteHandlingNotification->addChild('SpecifiedWasteHandlingNotificationEntry');
	$StorageStateInstallation = $specifiedWasteNotification->addChild('StorageStateInstallation');
	$StorageStateInstallation->addChild('ID', $row['site_gln']);
	$StorageStateInstallation->addChild('ReportingDate', $period."-01-01"); 
	$StoredMaterial = $StorageStateInstallation->addChild('StoredMaterial');
	$StoredMaterial->addChild('ClassificationCode', $row['waste_gtin']);
	$MassMeasurement = $StoredMaterial->addChild('MassMeasurement');
	$MassMeasurement->addChild('QuantificationTypeCode','9008390100011');
	$DeterminedMeasure = $MassMeasurement->addChild('DeterminedMeasure', $row['qnt']);
	$DeterminedMeasure->addAttribute('unitCode','KGM');
	$count_entry++;

}

$query_data =	 	"SELECT
						period, site_gln, waste_gtin, sum(quantity)::integer as qnt
					 FROM
						activity_edm_stock
					 WHERE
						period = '" . $period . "' and
						report_gln = '" . $gln . "'	and msg_type = 'Deponievolumen'
					 GROUP BY
						period, site_gln, waste_gtin
					";

$result_data = pg_query($query_data);
if (!$result_data)
{
	echo "Problem with query " . $result_data . "<br/>";
	echo pg_last_error();
	exit();
}

while($row = pg_fetch_assoc($result_data))
{

	$specifiedWasteNotification = $SpecifiedSinglePeriodWasteHandlingNotification->addChild('SpecifiedWasteHandlingNotificationEntry');
	$StorageStateInstallation = $specifiedWasteNotification->addChild('RemainingCapacityInstallation');
	$StorageStateInstallation->addChild('ID', $row['site_gln']);
	$StorageStateInstallation->addChild('ReportingDate', $period."-12-31");
	$physicalrem = $StorageStateInstallation->addChild('PhysicalRemainingCapacityMeasure',$row['qnt']);
	$physicalrem->addAttribute('unitCode','MTQ');
	$count_entry++;

}

$sql = 'select field from preset where section = \'database\' and param = \'content\'';
$qry = pg_query($sql);
$ret = pg_fetch_array($qry);
$content = $ret['field'];
if ($content === '')
{
	$content = 'content';
}

$filename = "/" . $content . "/EDM-Datenmeldung/edm_" . date('Ymdhms') . ".xml";

$dom = dom_import_simplexml($xml)->ownerDocument;
$dom->formatOutput = TRUE;
$xml = simplexml_load_string($dom->saveXML());

$xml->asXML($filename);

echo "XML Datei wurde erzeugt!<br>";

?>
