<!doctype html>
<?php
include('./include/config.inc.php');

if(!hasPermission("action_exit"))
{
	header('Location: index.php');
	die;
}

?>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="user-scalable=no, initial-scale=1, maximum-scale=1, minimum-scale=1, width=device-width">
	<meta name="mobile-web-app-capable" content="yes">
	<meta name="apple-mobile-web-app-capable" content="yes">
	<meta http-equiv="X-UA-Compatible" content="IE=edge"/>	
	<title>Waste Management System</title>
	<link rel="shortcut icon" href="favicon.ico">
	<link rel="stylesheet" href="css/jquery.mobile.structure.css">
	<link rel="stylesheet" href="css/jquery.mobile.theme.css">
	<link rel="stylesheet" href="css/jquery.mobile.icons.css">
	<link rel="stylesheet" href="css/wms.css">
	<link rel="stylesheet" href="css/wms.add.css">
	<script src="js/jquery.js"></script>
	<script src="js/jquery.mobile.js"></script>
	<script src="js/wms.js"></script>	
</head>
<body>

<div data-role="page">

	<?php
	include('js/header.php');
	?>
	<?php
	include('js/menu.php');
	?>
		
	<div role="main" class="ui-content">
		
		<ul data-role="listview" data-inset="true" data-filter="true" data-filter-placeholder="Evidenzsuche ...">				
		<?php
		
			$sql = "select 
						ap.description as cat, 
						ap.id as id, 
						count(ap.description) as cnt 
					from 
						activity a left join 
						contact c on a.contact = c.id left join 
						invoice i on i.year = a.invoice_year and i.nr = a.invoice_nr left join 
						appliance ap on a.destination_appliance = ap.id left outer join 
						paymenttype ip on ip.id = a.paymenttype 
					where 
						(a.host_info is null or a.host_info = '".$_COOKIE['username']."') and 
						(
							(a.delivery_year is null and a.invoice_year is null) or
							(
								(
									i.printed = false or 
									a.invoiced = false
								) and 
								ip.debitor is not null
							)
						)  
					group by 
						ap.description, 
						ap.id 
					order by 
						ap.description";	
			
			$cat = pg_query($db, $sql);
			
			while ($cow = pg_fetch_assoc($cat)) {
			?>						
				<li data-role="list-divider"><?php echo $cow['cat']; ?><span class="ui-li-count"><?php echo $cow['cnt']; ?></span></li>			
				<?php 		
				$sql = "select distinct 
							a.id, a.reference, 
							to_char(a.tara_in, '999G990D00') as tara_in, 
							to_char(a.tara_out, '999G990D00') as tara_out,
							to_char(a.quantity, '999G990D00') as quantity,
							a.tariff as tariff,
							a.start_timestamp, 
							a.delivery_year, 
							a.delivery_nr,
							t.description,
							coalesce(c.name1, '') || ' ' || coalesce(c.name2, '') as cname,
							ip.description as paytype
						from 
							activity a left join 
							contact c on a.contact = c.id left join 
							invoice i on i.year = a.invoice_year and i.nr = a.invoice_nr left join 
							appliance ap on a.destination_appliance = ap.id left outer join 
							paymenttype ip on ip.id = a.paymenttype left outer join
							tariff t on t.id = a.tariff
						where 
							(a.host_info is null or a.host_info = '".$_COOKIE['username']."') and 
							(
								(a.delivery_year is null and a.invoice_year is null) or 
								(
									(
										i.printed = false or 
										a.invoiced = false
									) and 
									ip.debitor is not null
								)
							) and   						
							a.destination_appliance = '".$cow['id']."' 
						order by 
							a.start_timestamp";
				
				$res = pg_query($db, $sql);
				while ($row = pg_fetch_assoc($res)) {				
					?>					
					<li>
					<?php
					if ($row['delivery_year'] == '') { 
						if ($row['tara_in'] == '') {
							
							$res = pg_query($db, 'select 
													a.id, 
													a.contact, 
													a.delivery_year, 
													a.reference
												from 
													activity a
												where 
													a.id = '.$row['id'].' and
													a.delivery_year is null and 
													a.quantity <> 0 and 
													a.start_timestamp is not null and 
													a.end_timestamp is not null and 
													a.tara_in is null and 
													a.tara_out is null
							');
							
							if ($res)
							{
							
								$row = pg_fetch_assoc($res);
								
								if ($row) 
								{
								
									$contact = $row['contact'];
									$reference = $row['reference'];
									$id = $row['id'];
									
									if ($row['delivery_year'] == '') {
										
										/*
										$res = pg_query($db, 'select do_delivery_contact(\''.$contact.'\', \''.$reference.'\')');
										if ($res) {
										?>
											<p><strong>Der Lieferschein wurde erstellt!</strong></p>
											<script type="text/javascript">
											window.location.href="action_exit_lsprint.php?id=<?php echo $id; ?>";
											</script>												
										<?php									
										} else { 
										?>
											<p><strong>ACHTUNG: Der Lieferschein konnte nicht erstellt werden! Die Einfahrt verbleibt in der Evidenzliste!</strong></p>
										<?php
											echo '<br>';
											echo '<p>';
											echo pg_last_error();
											echo '</p>';		
										}
										*/
										
										?>
										<p><strong>ACHTUNG: Es gibt eine unverbuchte offene Buchung!</strong></p>
										<?php
										
									} else {
										?>
										<a class="href" data-ajax="false" href="action_exit_lsprint.php?id=<?php echo $row['id']; ?>"> 
										<?php
									}
									
								}
								else
								{
									?>
										<p><strong>ACHTUNG: Eine offene Buchung konnte nicht zugeordnet werden</strong></p>
									<?php
								}
								
							}
							else
							{
								?>
								<p><strong>ACHTUNG: Eine offene Buchung konnte nicht verarbeitet werden!</strong></p>
								<?php
							}	
						} 
						else 
						{
					?>
							<a class="href" class="href" data-ajax="false" href="action_exit_tara.php?id=<?php echo $row['id']; ?>">
					<?php
						}
					} else { 
					?>
						<a class="href" data-ajax="false" href="action_exit_lsprint.php?id=<?php echo $row['id']; ?>"> 
					<?php
					} 
					?>
					<h2><?php echo $row['reference']; ?></h2>
					<p>
					Kunde: <?php echo $row['cname']; ?><br>
					Zahlungsart: <?php echo $row['paytype']; ?><br>
					Einfahrt: <?php echo $row['start_timestamp']; ?><br>
					Einfahrtsgewicht: <?php echo $row['tara_in']; ?><br>
					<?php
					if ($row['tara_out'] == '')						 
					{					
						echo '<font color="red">';
					}
					else
					{
						echo '<font color="green">';
					}
					?>
					Ausfahrtsgewicht: <?php echo $row['tara_out']; ?><br>
					Menge: <?php echo $row['quantity']; ?><br>
					Tarif: <?php echo $row['tariff'] . ' - ' . $row['description']; ?><br>
					</font>					
					<?php
					if ($row['delivery_year'] == '')						 
					{					
						echo '<font color="red">';
					}
					else
					{
						echo '<font color="green">';
					}
					?>					
					Lieferschein: <?php echo $row['delivery_year'].'/'.$row['delivery_nr']; ?><br>
					</font>
					</p>
					</a>
					</li>
			
					<?php 
							
				}
				
			}
						
		?>
		</ul>
					
	</div>

	<?php
	include('js/footer.php');
	?>
			
</div>

</body>
</html>
