<!doctype html>
<?php
include('./include/config.inc.php');

if(!hasPermission("list_activity"))
{
	header('Location: index.php');
	die;
}

?>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="user-scalable=no, initial-scale=1, maximum-scale=1, minimum-scale=1, width=device-width">
	<meta name="mobile-web-app-capable" content="yes">
	<meta name="apple-mobile-web-app-capable" content="yes">
	<meta http-equiv="X-UA-Compatible" content="IE=edge"/>	
	<title>Waste Management System</title>
	<link rel="shortcut icon" href="favicon.ico">
	<link rel="stylesheet" href="css/jquery.mobile.structure.css">
	<link rel="stylesheet" href="css/jquery.mobile.theme.css">
	<link rel="stylesheet" href="css/jquery.mobile.icons.css">
	<link rel="stylesheet" href="css/wms.css">
	<link rel="stylesheet" href="css/wms.add.css">
	<script src="js/jquery.js"></script>
	<script src="js/jquery.mobile.js"></script>
	<script src="js/wms.js"></script>	
</head>
<body>

<div data-role="page">

	<?php
	include('js/header.php');
	?>
	<?php
	include('js/menu.php');
	?>
		
	<div role="main" class="ui-content">
		
		<ul data-role="listview" data-inset="true" data-filter="true" data-filter-placeholder="Bewegungen ...">				
		<?php
	
		$res = pg_query($db, 'select 
								a.delivery_year, 
								a.delivery_nr, 
								a.id, 
								c.name1, 
								c.name2, 
								a.contact, 
								a.tariff, 
								t.description,
								a.source_appliance, 
								a.destination_appliance, 
								a.reference, 
								to_char(a.quantity, \'999G990D00\') as quantity, 
								to_char(a.tara_in, \'999G990\') as tara_in, 
								to_char(a.tara_out, \'999G990\') as tara_out, 
								to_char(a.gross_amount, \'999G990D00\') as gross_amount, 
								to_char(a.start_timestamp, \'HH24:MI\') as start_timestamp, 
								to_char(a.end_timestamp, \'HH24:MI\') as end_timestamp,
								a.remark,
								case when exists (select * from activity b where \'Storno zu \' || a.delivery_year || \'/\' || a.delivery_nr = b.remark) then
									\'STORNIERT\'
								else
									\'\'
								end as storno,
								p.description as paytype
							from 
								activity a, 
								contact c,
								tariff t,
								paymenttype p
							where 
								a.contact = c.id and 
								start_timestamp > current_date and 
								a.delivery_nr > 0 and a.delivery_year <> -1 and
								t.id = a.tariff and
								p.id = a.paymenttype
							order by 
								start_timestamp desc');
		while ($row = pg_fetch_assoc($res)) {
		
			?>
			<li>
			<?php
				if ($row['storno'] == '')
				{
			?>
			<a class="href" href="action_exit_lsprint.php?printcopy=yes&storno=yes&printonly=yes&id=<?php echo $row['id']; ?>">
			<?php
				}
				else 
				{
			?>
			<a class="href" href="action_exit_lsprint.php?printcopy=yes&printonly=yes&id=<?php echo $row['id']; ?>">
			<?php
				}
			?>
			<h2><?php echo $row['start_timestamp'].' '.$row['reference']; ?></h2>
			<p>
			Kunde: <?php echo $row['name1'].' '.$row['name2']; ?><br>
			Tariff: <?php echo $row['description']; ?><br>
			Lieferschein: <?php echo $row['delivery_year'].'/'.$row['delivery_nr']; ?><br>					
			Zahlungsart: <?php echo $row['paytype']; ?><br>
			Einfahrt: <?php echo $row['start_timestamp']; ?><br>
			Ausfahrt: <?php echo $row['end_timestamp']; ?><br>
			Quelle: <?php echo $row['source_appliance']; ?><br>
			Ziel: <?php echo $row['destination_appliance']; ?><br>
			Tarif: <?php echo $row['tariff']; ?><br>
			Gewicht: <?php echo $row['tara_in'].'/'.$row['tara_out']; ?><br>
			Menge: <?php echo $row['quantity']; ?><br>
			Brutto: <?php echo '€ '.$row['gross_amount']; ?><br>
			Bemerkung: <?php echo $row['remark']; ?><br>
			<font color="red">
			<?php echo $row['storno']; ?><br>
			</font>
			</p>
			</a>
			</li>
			<?php 
					
		}
				
		?>
		</ul>
					
	</div>

	<?php
	include('js/footer.php');
	?>
			
</div>

</body>
</html>
